from django.shortcuts import render_to_response
from django import newforms as forms
from yos.boss import ysearch
from yos.yql import db


def search(str):
    data = ysearch.search(str,vertical="news",count=10)
    news = db.create(data=data)
    return news.rows
    
class SearchForm(forms.Form):
    search_terms = forms.CharField(max_length=200)

def index(request):
    results = None
    if request.method == "POST":
        form = SearchForm(request.POST)
        if form.is_valid():
            search_terms = form.cleaned_data['search_terms']
            results = search(search_terms)
    else:
        form = SearchForm()
    return render_to_response('yahoo_search/index.html', {'form': form,'results': results})
